jQuery.extend({
		CROP_EVT_MOVE:"mousemove",
		CROP_EVT_DOWN:"mousedown",
		CROP_EVT_UP:"mouseup",

		crop_event: {},
		_crop_eventInfo:function(evt) {
			if (evt.targetTouches) {
				var t = evt.targetTouches[0];
				return {
					pageX:t.pageX,
					pageY:t.pageY
				};
			}
			else {
				return {
					pageX:evt.pageX,
					pageY:evt.pageY
				};
			}
		},
		_crop_unlock_body:function () {
			document.body.style.height = "";
			document.body.style.width = "";
		},
		_crop_lock_body:function () {
			var h = $(document.body).height();
			var w = $(document.body).width();
			document.body.style.height = h+"px";
			document.body.style.width = w+"px";
		},
		crop_move_content:function(evt) {
			var ei = jQuery._crop_eventInfo(evt);

			if (jQuery.crop_event.img && evt.metaKey) {
				var target = jQuery.crop_event.img;
				var dx = ei.pageX - jQuery.crop_event.x;
				var w = (jQuery.crop_event.iw + dx);
				if (w > 100) target.width = w;
			}
			else if (jQuery.crop_event.img) {
				var target = jQuery.crop_event.img;
				var dx = ei.pageX - jQuery.crop_event.x;
				var dy = ei.pageY - jQuery.crop_event.y;
				var l = jQuery.crop_event.l + dx;
				var t = jQuery.crop_event.t + dy;
				var w = jQuery.crop_event.w;
				var h = jQuery.crop_event.h;

				if (l > 1) l = 0;
				//if ((target.clientWidth + l) < w) l = w - target.clientWidth;
				
				if (t > 1) t = 0;
				//if ((target.clientHeight + t) < h) t = h- target.clientHeight;

				target.style["marginLeft"] = l + "px";
				target.style["marginTop"] = t + "px";
			}
			else if (jQuery.crop_event.resize) {
				var target = jQuery.crop_event.resize;
				var dx = ei.pageX - jQuery.crop_event.x;
				var dy = ei.pageY - jQuery.crop_event.y;
				var w = jQuery.crop_event.w + dx;
				var h = jQuery.crop_event.h + dy;

				if (w > 50) {
					target.style["width"] = w + "px";
				}
				if (h > 50) {
					target.style["height"] = h + "px";
				}
			}

			evt.preventDefault();
			return false;
		},
		crop_cancel:function(evt) {
			jQuery._crop_unlock_body();

			jQuery.crop_event.img = null;
			jQuery.crop_event.resize = null;

			document.removeEventListener(jQuery.CROP_EVT_MOVE, jQuery.crop_move_content, false);
			document.removeEventListener(jQuery.CROP_EVT_UP, jQuery.crop_cancel, false);

			evt.preventDefault();
			return false;
		},
		crop_move_start:function(evt) {
			jQuery.crop_event.img = evt.target;
			jQuery.crop_start(evt);

			evt.preventDefault();
			return false;
		},
		crop_resize_start:function(evt) {
			jQuery._crop_lock_body();
			jQuery.crop_event.resize = evt.target.parentElement;
			jQuery.crop_start(evt);

			evt.preventDefault();
			return false;
		},
		crop_start:function(evt) {
			var ei = jQuery._crop_eventInfo(evt);

			jQuery.crop_event.x = ei.pageX;
			jQuery.crop_event.y = ei.pageY;
			jQuery.crop_event.w = evt.target.parentElement.clientWidth;
			jQuery.crop_event.h = evt.target.parentElement.clientHeight;
			jQuery.crop_event.iw = evt.target.width;
			jQuery.crop_event.ih = evt.target.height;

			var l = evt.target.style.marginLeft;
			var t = evt.target.style.marginTop;

			if (l == "") l = 0;
			else l = parseInt(l.substr(0, l.length-2));
			if (t == "") t = 0;
			else t = parseInt(t.substr(0, t.length-2));

			jQuery.crop_event.l = l;
			jQuery.crop_event.t = t;

			document.addEventListener(jQuery.CROP_EVT_MOVE, jQuery.crop_move_content, false);
			document.addEventListener(jQuery.CROP_EVT_UP, jQuery.crop_cancel, false);
		},
    mk_crop_frame: function (img) {
			var p = img.parentElement;
			var w = p.style.width;
			var h = p.style.height;
			if (w == "") w = img.width + "px";
			if (h == "") h = img.height + "px";

			if (!p.classList.contains("ui-cropframe")) {
				var el = document.createElement("div");
				el.classList.add("ui-cropframe");
				el.style.overflow = "hidden";
				el.style.width = w;
				el.style.height = h;
				el.style.position = "relative";
				img.parentElement.replaceChild(el, img);
				el.appendChild(img);

				var handle = document.createElement("div");
				handle.classList.add("ui-cropframe-handle");
				handle.style.width = "40px";
				handle.style.height = "40px";
				handle.style.position = "absolute";
				handle.style.bottom = "0px";
				handle.style.right = "0px";
				el.appendChild(handle);

				img.addEventListener(jQuery.CROP_EVT_DOWN, this.crop_move_start, false);
				handle.addEventListener(jQuery.CROP_EVT_DOWN, this.crop_resize_start, false);
			}
			if (p.classList.contains("img-wrapper")) {
				p.style.width = null;
				p.style.height = null;
			}
    },
    rm_crop_frame: function (img) {
			jQuery._crop_unlock_body();
			var p = img.parentElement;

			img.removeEventListener(jQuery.CROP_EVT_DOWN, this.crop_move_start, false);
			$(p).find("ui-cropframe-handle").each(function(n, it) {
				it.removeEventListener(jQuery.CROP_EVT_DOWN, this.crop_resize_start, false);
			});

			if (p.classList.contains("ui-cropframe")) {
				var ip = p.parentElement;
				ip.style.width = p.style.width;
				ip.style.height = p.style.height;
				p.parentElement.replaceChild(img, p);
			}
		}
});

jQuery.fn.crop = function (options) {
	if ("ontouchstart" in window) {
		jQuery.CROP_EVT_MOVE = "touchmove";
		jQuery.CROP_EVT_DOWN = "touchstart";
		jQuery.CROP_EVT_UP = "touchend";
	}

	if (options == "destroy") {
		this.each(function(n,it) {
			jQuery.rm_crop_frame(it);
		});
	}
	else {
    var settings = {}; 

    jQuery.extend(settings, options);
		this.each(function(n,it) {
			jQuery.mk_crop_frame(it);
		});
	}
};
